Subject: libhdf4: ftbfs with GCC-15

From: Matthias Klose <[email-masked]>
Date: Mon, 17 Feb 2025 17:31:24 +0000

Package: src:libhdf4
Version: 4.3.0-1
Severity: important
Tags: sid forky
User: [email-masked]
Usertags: ftbfs-gcc-15

[This bug is NOT targeted to the upcoming trixie release]

Please keep this issue open in the bug tracker for the package it
was filed for.  If a fix in another package is required, please
file a bug for the other package (or clone), and add a block in this
package. Please keep the issue open until the package can be built in
a follow-up test rebuild.

The package fails to build in a test rebuild on at least amd64 with
gcc-15/g++-15, but succeeds to build with gcc-14/g++-14. The
severity of this report will be raised before the forky release.

The full build log can be found at:
http://qa-logs.debian.net/2025/02/16/amd64exp/libhdf4_4.3.0-1_unstable_gccexp.log.gz
The last lines of the build log are at the end of this report.

To build with GCC 15, either set CC=gcc-15 CXX=g++-15 explicitly,
or install the gcc, g++, gfortran, ... packages from experimental.

  apt-get -t=experimental install g++ 

GCC 15 now defaults to the C23/C++23 standards, exposing many FTBFS.
Other Common build failures are new warnings resulting in build failures
with -Werror turned on, or new/dropped symbols in Debian symbols files.
For other C/C++ related build failures see the porting guide at
http://gcc.gnu.org/gcc-15/porting_to.html

[...]
../../../../HDF4.3.0/mfhdf/libsrc/nc_priv.h:432:18: note: 'xdr_NC_var' declared here
  432 | HDFLIBAPI bool_t xdr_NC_var(XDR *xdrs, NC_var **vpp);
      |                  ^~~~~~~~~~
../../../../HDF4.3.0/mfhdf/libsrc/array.c:528:25: error: assignment to 'bool_t (*)(void)' {aka 'int (*)(void)'} from incompatible pointer type 'bool_t (*)(XDR *, NC_attr **)' {aka 'int (*)(struct xinfo *, NC_attr **)'} [-Wincompatible-pointer-types]
  528 |             xdr_NC_fnct = xdr_NC_attr;
      |                         ^
../../../../HDF4.3.0/mfhdf/libsrc/nc_priv.h:427:18: note: 'xdr_NC_attr' declared here
  427 | HDFLIBAPI bool_t xdr_NC_attr(XDR *xdrs, NC_attr **app);
      |                  ^~~~~~~~~~~
../../../../HDF4.3.0/mfhdf/libsrc/array.c:537:17: error: too many arguments to function 'xdr_NC_fnct'; expected 0, have 2
  537 |         stat = (*xdr_NC_fnct)(xdrs, vp);
      |                ~^~~~~~~~~~~~~ ~~~~
../../../../HDF4.3.0/mfhdf/libsrc/array.c:546:13: error: too many arguments to function 'xdr_NC_fnct'; expected 0, have 3
  546 |     stat = (*xdr_NC_fnct)(xdrs, vp, *countp);
      |            ~^~~~~~~~~~~~~ ~~~~
make[4]: *** [Makefile:648: array.lo] Error 1
make[4]: *** Waiting for unfinished jobs....
../../../../HDF4.3.0/mfhdf/libsrc/cdf.c: In function 'xdr_NC_fill':
../../../../HDF4.3.0/mfhdf/libsrc/cdf.c:2396:25: error: assignment to 'bool_t (*)(void)' {aka 'int (*)(void)'} from incompatible pointer type 'bool_t (*)(XDR *, char **, unsigned int *, unsigned int)' {aka 'int (*)(struct xinfo *, char **, unsigned int *, unsigned int)'} [-Wincompatible-pointer-types]
 2396 |             xdr_NC_fnct = h4_xdr_bytes;
      |                         ^
In file included from ../../../../HDF4.3.0/mfhdf/libsrc/nc_priv.h:31,
                 from ../../../../HDF4.3.0/mfhdf/libsrc/cdf.c:17:
../../../../HDF4.3.0/mfhdf/libsrc/h4_xdr_priv.h:106:18: note: 'h4_xdr_bytes' declared here
  106 | HDFLIBAPI bool_t h4_xdr_bytes(XDR *, char **, unsigned *, unsigned);
      |                  ^~~~~~~~~~~~
../../../../HDF4.3.0/mfhdf/libsrc/cdf.c:2400:25: error: assignment to 'bool_t (*)(void)' {aka 'int (*)(void)'} from incompatible pointer type 'bool_t (*)(XDR *, short int *)' {aka 'int (*)(struct xinfo *, short int *)'} [-Wincompatible-pointer-types]
 2400 |             xdr_NC_fnct = xdr_2shorts;
      |                         ^
../../../../HDF4.3.0/mfhdf/libsrc/cdf.c:2354:1: note: 'xdr_2shorts' declared here
 2354 | xdr_2shorts(XDR *xdrs, short *sp)
      | ^~~~~~~~~~~
../../../../HDF4.3.0/mfhdf/libsrc/cdf.c:2404:25: error: assignment to 'bool_t (*)(void)' {aka 'int (*)(void)'} from incompatible pointer type 'bool_t (*)(XDR *, int *)' {aka 'int (*)(struct xinfo *, int *)'} [-Wincompatible-pointer-types]
 2404 |             xdr_NC_fnct = h4_xdr_int;
      |                         ^
../../../../HDF4.3.0/mfhdf/libsrc/h4_xdr_priv.h:103:18: note: 'h4_xdr_int' declared here
  103 | HDFLIBAPI bool_t h4_xdr_int(XDR *, int *);
      |                  ^~~~~~~~~~
../../../../HDF4.3.0/mfhdf/libsrc/cdf.c:2408:25: error: assignment to 'bool_t (*)(void)' {aka 'int (*)(void)'} from incompatible pointer type 'bool_t (*)(XDR *, float *)' {aka 'int (*)(struct xinfo *, float *)'} [-Wincompatible-pointer-types]
 2408 |             xdr_NC_fnct = h4_xdr_float;
      |                         ^
../../../../HDF4.3.0/mfhdf/libsrc/h4_xdr_priv.h:109:18: note: 'h4_xdr_float' declared here
  109 | HDFLIBAPI bool_t h4_xdr_float(XDR *, float *);
      |                  ^~~~~~~~~~~~
../../../../HDF4.3.0/mfhdf/libsrc/cdf.c:2412:25: error: assignment to 'bool_t (*)(void)' {aka 'int (*)(void)'} from incompatible pointer type 'bool_t (*)(XDR *, double *)' {aka 'int (*)(struct xinfo *, double *)'} [-Wincompatible-pointer-types]
 2412 |             xdr_NC_fnct = h4_xdr_double;
      |                         ^
../../../../HDF4.3.0/mfhdf/libsrc/h4_xdr_priv.h:110:18: note: 'h4_xdr_double' declared here
  110 | HDFLIBAPI bool_t h4_xdr_double(XDR *, double *);
      |                  ^~~~~~~~~~~~~
../../../../HDF4.3.0/mfhdf/libsrc/cdf.c:2421:17: error: too many arguments to function 'xdr_NC_fnct'; expected 0, have 2
 2421 |         stat = (*xdr_NC_fnct)(xdrs, fillp);
      |                ~^~~~~~~~~~~~~ ~~~~
make[4]: *** [Makefile:648: cdf.lo] Error 1
libtool: compile:  gcc -DHAVE_CONFIG_H -I. -I../../../../HDF4.3.0/mfhdf/libsrc -I../../hdf/src -I../../../../HDF4.3.0/hdf/src -I../../../../HDF4.3.0/mfhdf/libsrc -DHDF -D_POSIX_C_SOURCE=200809L -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -DNDEBUG -g -O2 -Werror=implicit-function-declaration -ffile-prefix-map=/build/reproducible-path/libhdf4-4.3.0=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -c ../../../../HDF4.3.0/mfhdf/libsrc/iarray.c -o iarray.o >/dev/null 2>&1
libtool: compile:  gcc -DHAVE_CONFIG_H -I. -I../../../../HDF4.3.0/mfhdf/libsrc -I../../hdf/src -I../../../../HDF4.3.0/hdf/src -I../../../../HDF4.3.0/mfhdf/libsrc -DHDF -D_POSIX_C_SOURCE=200809L -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -DNDEBUG -g -O2 -Werror=implicit-function-declaration -ffile-prefix-map=/build/reproducible-path/libhdf4-4.3.0=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -c ../../../../HDF4.3.0/mfhdf/libsrc/error.c -o error.o >/dev/null 2>&1
libtool: compile:  gcc -DHAVE_CONFIG_H -I. -I../../../../HDF4.3.0/mfhdf/libsrc -I../../hdf/src -I../../../../HDF4.3.0/hdf/src -I../../../../HDF4.3.0/mfhdf/libsrc -DHDF -D_POSIX_C_SOURCE=200809L -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -DNDEBUG -g -O2 -Werror=implicit-function-declaration -ffile-prefix-map=/build/reproducible-path/libhdf4-4.3.0=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -c ../../../../HDF4.3.0/mfhdf/libsrc/attr.c -o attr.o >/dev/null 2>&1
libtool: compile:  gcc -DHAVE_CONFIG_H -I. -I../../../../HDF4.3.0/mfhdf/libsrc -I../../hdf/src -I../../../../HDF4.3.0/hdf/src -I../../../../HDF4.3.0/mfhdf/libsrc -DHDF -D_POSIX_C_SOURCE=200809L -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -DNDEBUG -g -O2 -Werror=implicit-function-declaration -ffile-prefix-map=/build/reproducible-path/libhdf4-4.3.0=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -c ../../../../HDF4.3.0/mfhdf/libsrc/dim.c -o dim.o >/dev/null 2>&1
libtool: compile:  gcc -DHAVE_CONFIG_H -I. -I../../../../HDF4.3.0/mfhdf/libsrc -I../../hdf/src -I../../../../HDF4.3.0/hdf/src -I../../../../HDF4.3.0/mfhdf/libsrc -DHDF -D_POSIX_C_SOURCE=200809L -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -DNDEBUG -g -O2 -Werror=implicit-function-declaration -ffile-prefix-map=/build/reproducible-path/libhdf4-4.3.0=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -c ../../../../HDF4.3.0/mfhdf/libsrc/file.c -o file.o >/dev/null 2>&1
libtool: compile:  gcc -DHAVE_CONFIG_H -I. -I../../../../HDF4.3.0/mfhdf/libsrc -I../../hdf/src -I../../../../HDF4.3.0/hdf/src -I../../../../HDF4.3.0/mfhdf/libsrc -DHDF -D_POSIX_C_SOURCE=200809L -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -DNDEBUG -g -O2 -Werror=implicit-function-declaration -ffile-prefix-map=/build/reproducible-path/libhdf4-4.3.0=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/ -c ../../../../HDF4.3.0/mfhdf/libsrc/hdfsds.c -o hdfsds.o >/dev/null 2>&1
make[4]: Leaving directory '/build/reproducible-path/libhdf4-4.3.0/debian/build-hdf4/mfhdf/libsrc'
make[3]: *** [Makefile:490: all-recursive] Error 1
make[3]: Leaving directory '/build/reproducible-path/libhdf4-4.3.0/debian/build-hdf4/mfhdf'
make[2]: *** [Makefile:582: all-recursive] Error 1
make[2]: Leaving directory '/build/reproducible-path/libhdf4-4.3.0/debian/build-hdf4'
dh_auto_build: error: cd debian/build-hdf4 && make -j8 F77=gfortran CC=gcc CXX=g\+\+ "CFLAGS=-g -O2 -Werror=implicit-function-declaration -ffile-prefix-map=/build/reproducible-path/libhdf4-4.3.0=. -fstack-protector-strong -fstack-clash-protection -Wformat -Werror=format-security -fcf-protection -Wdate-time -D_FORTIFY_SOURCE=2 -I/usr/include/tirpc/" "LDFLAGS=-Wl,-z,relro -Wl,-z,now -ltirpc" "LIBS=-ljpeg -lz -lm" returned exit code 2
make[1]: *** [debian/rules:106: override_dh_auto_build] Error 25
make[1]: Leaving directory '/build/reproducible-path/libhdf4-4.3.0'
make: *** [debian/rules:54: binary] Error 2
dpkg-buildpackage: error: debian/rules binary subprocess returned exit status 2